<div align="center">

![devchat](https://github.com/covespace/devchat/assets/592493/f39979fe-fe32-410b-bf9d-2118ac8ea3d5)

# DevChat

<br>

[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com)
[![CircleCI](https://circleci.com/gh/covespace/devchat/tree/main.svg?style=shield)](https://circleci.com/gh/covespace/devchat/tree/main)
[![GitHub license](https://img.shields.io/github/license/covespace/devchat.svg)](https://github.com/covespace/devchat/blob/main/LICENSE)
[![Downloads](https://pepy.tech/badge/devchat)](https://pepy.tech/project/devchat)
[![PyPI version](https://badge.fury.io/py/devchat.svg)](https://badge.fury.io/py/devchat)
[![Discord Chat](https://img.shields.io/discord/1106908489114206309?logo=discord)](https://discord.gg/9t3yrbBUXD)

</div>
<br>
<div align="left">

The DevChat core library and CLI.

👉 For a better experience, check out our [Visual Studio Code extension](https://github.com/covespace/devchat-vscode) on [Visual Studio Marketplace](https://marketplace.visualstudio.com/items?itemName=merico.devchat)! Install and enjoy the enhanced UI 👏

***

## What is DevChat?

DevChat is an open-source tool that helps you write prompts to generate code and documentation.
It is _not_ limited to performing predefined operations on short code snippets.
  
DevChat is the way developers interact and collaborate with AI.

💬 Build the future with prompts, _not_ code.

## Why DevChat?

- To enable AI to write code, DevChat assists you in providing **the right context** for AI.
  
  ![20230519-231038-00 00 00 000-00 00 20 989](https://github.com/covespace/devchat-vscode/assets/592493/cfb96c7f-bd45-4573-810e-17148aac79d1)
  
  Chat history, code, files, directory trees, `git diff --cached`, or the output of any command.

- To apply AI-generated code, DevChat streamlines your **actions to take**.

  ![20230519-231038-00 00 24 989-00 00 44 688](https://github.com/covespace/devchat-vscode/assets/592493/2a0c4acf-6801-409c-bb18-ac75bae96938)
  
  View diffs, copy or insert, commit & sync, or export to documentation, wikis, and more.
  
- To guide AI in your work, define **your own workflows** with DevChat.
  
  ![20230519-231038-00 00 45 034-00 01 00 000](https://github.com/covespace/devchat-vscode/assets/592493/5a72e43f-0ed9-446a-81be-3e5f00009961)
  
  More prompt templates, iterative calls to AI, and program operations.

- To suit your preferences, customize **your own experiences** with DevChat.
  
  Open-source, no waiting for opaque feature schedules. Access GPT-4 today and more models in the future.
  
## What is Prompt-Centric Software Development (PSSD)?

- The traditional code-centric paradigm is evolving.

- Write prompts to create code. Transform prompts into everything.

  <img width="600" alt="image" src="https://github.com/covespace/devchat/assets/592493/dd32e900-92fd-4fa4-8489-96ed17ab5e0e">

  <sub>(This image is licensed by devchat.ai under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.)</sub>
  
- It is DevPromptOps
  
  <img width="500" alt="image" src="https://github.com/covespace/devchat/assets/592493/e8e1215b-53b0-4473-ab00-0665d33f204a">
  
  <sub>(This image is licensed by devchat.ai under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.)</sub>

***

## Quick Start

For UI, install the [Visual Studio Code extension](https://github.com/covespace/devchat-vscode) from [Visual Studio Marketplace](https://marketplace.visualstudio.com/items?itemName=merico.devchat).

For CLI:
- Install DevChat by running: `pip install devchat`.
- Make sure you are working in a Git repository, as DevChat only works within one.
- Set your [OpenAI API Key](https://platform.openai.com/account/api-keys) by running `export OPENAI_API_KEY="[sk-...]"`.
- To access help, use the commands: `devchat --help` and `devchat prompt --help`.

## Community

- Join our [Discord](https://discord.gg/9t3yrbBUXD)!

- Participate in [discussions](https://github.com/covespace/devchat/discussions)!

## Contributing

Issues and pull request are welcome: https://github.com/covespace/devchat/issues
  
## Roadmap

- [x] Implement code diff application.
- [ ] Improve code diff application using code change instructions.
- [ ] Develop a framework for defining workflows.
- [ ] Implement topic management.
- [ ] Enable interaction with external development tools.
- [ ] Introduce more selective workflows.
  
## Contact
  
hello@merico.dev

We are creators of [Apache DevLake](https://devlake.apache.org/).

